/*
	sndtest.C

	Driver Program to Test the SND TSR

	Written by: Geoff Friesen (November, 1991)
*/

#include <dos.H>
#include <process.H>
#include <stdio.H>

#define	NOTFOUND	0

void	NoSound	(void);
void	Pause	(unsigned ticks);
int	Search	(void);
void	Sound	(unsigned frequency);
int	Version	(void);

void main (void)
{

   fprintf (stderr, "ͻ\n");
   fprintf (stderr, " SNDTEST \n");
   fprintf (stderr, "ͼ\n\n");

   if (Search () == NOTFOUND)
   {
       fprintf (stderr, "sndtest: SND not installed\n");
       exit (1);
   }

   fprintf (stderr, "sndtest: SND version %d installed.\n", Version ());

   Sound (1000);
   Pause (36);
   NoSound ();
}

void NoSound (void)
{
   union REGS regs;

   regs.h.ah = 0xff;
   regs.h.al = 3;
   int86 (0x1a, &regs, &regs);
}

void Pause (unsigned ticks)
{
   union REGS regs;

   regs.h.ah = 0xff;
   regs.h.al = 1;
   regs.x.dx = ticks;
   int86 (0x1a, &regs, &regs);
}

int Search (void)
{
   unsigned segment = 0x40;

   do
   {
      if (~peekb(segment, 0x103) == 'S' &&
	  peekb(segment, 0x104) == 'N' &&
	  peekb(segment, 0x105) == 'D')
	  return !NOTFOUND;
      else
	  segment++;
   }
   while (segment != 0xa000);

   return NOTFOUND;
}

void Sound (unsigned frequency)
{
   union REGS regs;

   regs.h.ah = 0xff;
   regs.h.al = 2;
   regs.x.dx = frequency;
   int86 (0x1a, &regs, &regs);
}

int Version (void)
{
   union REGS regs;

   regs.h.ah = 0xff;
   regs.h.al = 0;
   int86 (0x1a, &regs, &regs);

   return regs.h.al;
}